#ifndef INCLUDE_cvlib_H_
#define INCLUDE_cvlib_H_

/*
cvlib : flext-based opencv librairy (c) 2009 by jy gratius
based on flext layer

Flext Copyright (c) 2002,2003 Thomas Grill (xovo@gmx.net)
For information on usage and redistribution, and for a DISCLAIMER OF ALL
WARRANTIES, see the file, "license.txt," in this distribution.

-------------------------------------------------------------------------

*/

// disable attribute processing
// For clarity, this is done here, but you'd better specify it as a compiler definition
#define FLEXT_ATTRIBUTES 0

// verbose flag for debugging purposes
#define CVLIB_VERBOSE 0

//#define cvlib_error post

/*
// include flext header
#ifndef FLEXT_THREADS
#define FLEXT_THREADS
#endif
*/
// ----------------------------------
// opencv headers

#include "cv.h"
#include "highgui.h"



#include <flext.h>

// check for appropriate flext version
#if !defined(FLEXT_VERSION) || (FLEXT_VERSION < 400)
#error You need at least flext version 0.4.0
#endif

// set all cvlib #define values
#include "cvlib_defines.h"


 // clear structure  TO DO : check and free pointed dynamic structures

void cvlib_reset();

// -------------------------------------------------------------------------------------
// Define the base class
// Note that you don't have to instantiate the base class (with FLEXT_NEW or variants)

// check if current position points to an IplImage
	bool cvlib_isIplImage(int index);


 // create new <anything> header
    int cvlib_createHeader (int type,int status);

// free array position
	int cvlib_freeHeader(int index);

//  get array position type
	int cvlib_get_type(int index);

//  get array position status
	int cvlib_get_status(int index);

//  get array position data pointer
    void* cvlib_get_pdata(int index);

//  set data pointer at array[index] position
    int cvlib_set_pdata(int index, void* pointer);


/// find next free position in array and set cvlib_blank_index;
    int cvlib_find_next_blank();

    // check if IplImage exist, release and recreate it if necessary
    int cvlib_prepareIplImage(IplImage ** pmy_image, int width, int height, int nChannels);

    int cvlib_getIplImageColorspace(IplImage *my_image);

    void cvlib_setIplImageColorspace(IplImage *my_image,int gl_colorspace);







// container struct for image and object pointers
typedef struct cvlib_pool_tag {
	int type;
	int status;
	void * pInstance;
} cvlib_pool_struct;


// end of #ifndef statement
#endif
