#include "cvlib_ImageFilter_0_1.h"





//****************************************************************
// cvlib_base methods

// *********** CONSTRUCTOR *****************

cvlib_ImageFilter_0_1::cvlib_ImageFilter_0_1()
{
	// define inlets:
	// first inlet must always by of type anything (or signal for dsp objects)
	AddInAnything();  // add one inlet for any message
    AddOutAnything();  // add one outlet for any message

    // allocate sid and register it for cvImageDest
    cvImageDestSID=cvlib_createHeader(CVLIB_TYPE_IPLIMAGE,CVLIB_STATUS_DATA_NOT_OWNED);


        // filling tables of symbols with corresponding tag names

    cvlib_tagImage=gensym("cvImage");
    cvlib_tagGemState=gensym("gem_state");
    cvlib_tagContour=gensym("cvContour");


	// register methods
    FLEXT_ADDBANG(0,generate_cvImage);
}

// DESTRUCTOR

cvlib_ImageFilter_0_1::~cvlib_ImageFilter_0_1()
{
    if (cvImageDest)
        cvReleaseImage( &cvImageDest);
    cvlib_freeHeader(cvImageDestSID);
}




//   helper function : check if source image has changed
//                            source image size has changed
//  prepare dest image accordingly

/// TO DO : add a argument to tell if COI/ROI supported
///  if not, create a copy (using COI/ROI) and substitute to SourceImage pointer

//  output any data stored in cvlib_pool, prepending sid by appropriate tag

void cvlib_ImageFilter_0_1::outputTaggedSID(int outlet, int sid)
{
    t_atom my_output;
    int status=cvlib_get_status(sid);
    if ((status!=CVLIB_STATUS_NULL)&&(status!=CVLIB_STATUS_ERROR))
    {
        int type=cvlib_get_type(sid);
        switch (type)
        {
            case CVLIB_TYPE_IPLIMAGE:
            {
                SETFLOAT(&my_output,sid);
                ToOutAnything(outlet,cvlib_tagImage,1,&my_output);
            }
            break;
            case CVLIB_TYPE_CONTOUR:
            {
                SETFLOAT(&my_output,sid);
                ToOutAnything(outlet,cvlib_tagContour,1,&my_output);
            }
            break;
            default: break;
        }
    }
}



void cvlib_ImageFilter_0_1::output_format(int i)
    {
        output_format_flag=i;
    }

void cvlib_ImageFilter_0_1::processImage_0_1 ()
 {
     //virtual function overrided by real class definition
 }

 void cvlib_ImageFilter_0_1::generate_cvImage()
{

    processImage_0_1();

    // Copy Image Dest into cvlib structure
    /// NEW :  COPY IMAGE DEST POINTER
    cvlib_set_pdata(cvImageDestSID, &cvImageDest);
        // send dest image sid tag
    outputTaggedSID(0, cvImageDestSID);

}



