#ifndef INCLUDE_cvlib_ImageFilter_0_1_H_
#define INCLUDE_cvlib_ImageFilter_0_1_H_

/*
cvlib : flext-based opencv librairy (c) 2009 by jy gratius
based on flext layer

Flext Copyright (c) 2002,2003 Thomas Grill (xovo@gmx.net)
For information on usage and redistribution, and for a DISCLAIMER OF ALL
WARRANTIES, see the file, "license.txt," in this distribution.

-------------------------------------------------------------------------

*/

// opencv headers

#include "cv.h"
#include "highgui.h"



#include <flext.h>

// check for appropriate flext version
#if !defined(FLEXT_VERSION) || (FLEXT_VERSION < 400)
#error You need at least flext version 0.4.0
#endif

// set all cvlib #define values
#include "cvlib_defines.h"
#include "cvlib.h"

// -------------------------------------------------------------------------------------
// Define the base class cvlib_ImageFilter_0_1
// Note that you don't have to instantiate the base class (with FLEXT_NEW or variants)

class cvlib_ImageFilter_0_1:
	// inherit from basic flext class
	public flext_base
{
	// obligatory flext header (class name,base class name)
	FLEXT_HEADER(cvlib_ImageFilter_0_1,flext_base)

public:
	// constructor
	cvlib_ImageFilter_0_1();



protected:
    // DESTRUCTOR
    virtual ~cvlib_ImageFilter_0_1();

    virtual void processImage_0_1 ();

    void generate_cvImage();

    int prepare_dest_image();
    void send_cvImageDestSID();
   void outputTaggedSID(int outlet, int sid);

    void output_format(int i);

    int output_format_flag;
    IplImage *cvImageDest;


private:

    int cvImageDestSID;

  //  CvRect my_ROI;
  //  int my_COI;
    int dest_width;
    int dest_height;



/// variables for storing tags (I don't know if gensym is a macro or a function.)

const t_symbol  *cvlib_tagImage,
                *cvlib_tagGemState,
                *cvlib_tagContour;


    FLEXT_CALLBACK(generate_cvImage)
};


// end of #ifndef statement
#endif
