#ifndef INCLUDE_cvlib_ImageFilter_1_1_H_
#define INCLUDE_cvlib_ImageFilter_1_1_H_

/*
cvlib : flext-based opencv librairy (c) 2009 by jy gratius
based on flext layer

Flext Copyright (c) 2002,2003 Thomas Grill (xovo@gmx.net)
For information on usage and redistribution, and for a DISCLAIMER OF ALL
WARRANTIES, see the file, "license.txt," in this distribution.

-------------------------------------------------------------------------

*/

// opencv headers

#include "cv.h"
#include "highgui.h"



#include <flext.h>

// check for appropriate flext version
#if !defined(FLEXT_VERSION) || (FLEXT_VERSION < 400)
#error You need at least flext version 0.4.0
#endif

// set all cvlib #define values
#include "cvlib_defines.h"
#include "cvlib.h"

#include "gem_headers.h"
// -------------------------------------------------------------------------------------
// Define the base class cvlib_ImageFilter_1_1
// Note that you don't have to instantiate the base class (with FLEXT_NEW or variants)

class cvlib_ImageFilter_1_1:
	// inherit from basic flext class
	public flext_base
{
	// obligatory flext header (class name,base class name)
	FLEXT_HEADER(cvlib_ImageFilter_1_1,flext_base)

public:
	// constructor
	cvlib_ImageFilter_1_1();



protected:
    // DESTRUCTOR
    virtual ~cvlib_ImageFilter_1_1();

 //   virtual void processImage_1_1 ();

    void process_cvImage(int sid);          // process when cvImage tag received
    void reprocess_cvImage();               // process when bang received

    void process_gem_state(int argc, t_atom *argv);// process when gem_state pointer received

    void outputTaggedSID(int outlet, int sid); // method for outputting tags

    int check_roi_and_process_IplImage(IplImage * &Source, IplImage * &Dest); //

    int process_IplImage(IplImage * &Source, IplImage * &Dest); // the function that routes processing to specific
                            // routing, according to nb of channels and colorspace

/// TO DO : ADD YUV SUPPORT

    virtual int process_roi_IplImage(IplImage * &Source, IplImage * &Dest); // function to overwrite if roi supported
    virtual int process_default_image(IplImage * &Source, IplImage * &Dest);
    virtual int process_4channels_image(IplImage * &Source, IplImage * &Dest);
    virtual int process_RGBA_image(IplImage * &Source, IplImage * &Dest);
    virtual int process_BGRA_image(IplImage * &Source, IplImage * &Dest);
    virtual int process_3channels_image(IplImage * &Source, IplImage * &Dest);
    virtual int process_RGB_image(IplImage * &Source, IplImage * &Dest);
    virtual int process_BGR_image(IplImage * &Source, IplImage * &Dest);
    virtual int process_2channels_image(IplImage * &Source, IplImage * &Dest);
    virtual int process_1channel_image(IplImage * &Source, IplImage * &Dest);

    // the OpenCV IplImage structure used for pixBlock conversion
    IplImage *cvGemImage;

    IplImage *cvImageSource;
    IplImage *cvImageDest;
    IplImage **pcvImageSource;

    int dest_width;  /// not used
    int dest_height;/// not used
    int dest_channels;/// not used

    int just_instantiated;

    int output_dirty_flag;



private:

   int gemImageSourceHeight;
    int gemImageSourceWidth;
    int gemImageSourceChannels;

    int cvImageSourceSID;
    int cvImageSourceColorModel;

    int cvImageDestSID;
    //  CvRect my_ROI;
  //  int my_COI;

    /// variables for storing tags (I don't know if gensym is a macro or a function.)
    const t_symbol  *cvlib_tagImage,
                    *cvlib_tagGemState,
                    *cvlib_tagContour;
    t_atom flag;
    // image buffer and pix structures
    pixBlock * previousPixblock;
    pixBlock output_pixBlock;
 //   imageStruct output_imageStruct;
  //  PBYTE pBuffer;
    GemState *input_gem_state_pointer;
    GemState *output_gem_state_pointer;/// not used

     char * input_image_data;

    int input_image_type_has_changed;/// not used
    int output_image_type_has_changed;/// not used


    FLEXT_CALLBACK_I(process_cvImage)
    FLEXT_CALLBACK(reprocess_cvImage)
    FLEXT_CALLBACK_G(process_gem_state)
};


// end of #ifndef statement
#endif
