#include "cvlib_ImageFilter_2_1.h"





//****************************************************************
// cvlib_base methods

// *********** CONSTRUCTOR *****************

cvlib_ImageFilter_2_1::cvlib_ImageFilter_2_1()
{


	AddInAnything();  // add right inlet for second image data

	// register methods for right inlet
        FLEXT_ADDMETHOD_I(1,"cvImage",process_cvImage_right_inlet);  // register method for tag "cvImage" and int argument
        FLEXT_ADDMETHOD_(1,"gem_state", process_gem_state_right_inlet);
        cvImageSourceRight_has_changed=0;
}

// DESTRUCTOR

cvlib_ImageFilter_2_1::~cvlib_ImageFilter_2_1()
{

}



// functions attached to right inlet

 void cvlib_ImageFilter_2_1::process_cvImage_right_inlet(int sid)
{
    if (cvlib_isIplImage(sid))
    {
        // retrieve IplImage pointer from sid
        pcvImageSourceRight=(IplImage **)cvlib_get_pdata(sid);

        // load new cvImageSource
        cvImageSourceRight=(IplImage *)*pcvImageSourceRight;

        /// TO DO : replace with call to virtual function "right_image_has_changed"
        // signals that right input image has changed
        cvImageSourceRight_has_changed=1;


            /// output_dirty_flag not necessary here : should be handled
            /// by derived class
            output_dirty_flag=1;


    }
    else
        cvlib_error("cvImage index %d doesn't correspond to an image", sid);
}


void cvlib_ImageFilter_2_1::process_gem_state_right_inlet(int argc, t_atom *argv)
{
    // gem_state tag recognized

    int result;
    input_image_type_right_has_changed=0;

    // check if format received is : gem_state (pointer) (pointer)
    if (argc==2)
    if (CanbePointer(argv[1]))
    {
        //can be pointer
        input_gem_state_pointer_right =  (GemState *) GetPointer(argv[1]);
        if ((!input_gem_state_pointer_right)|| (!input_gem_state_pointer_right->image))
        {
            //no pixblock !!
            input_image_type_right_has_changed = 1;  /// ?????
            input_image_data_right = 0;               /// ?????
        }
        else
        {
            if  (&input_gem_state_pointer_right->image->image == 0)
            {
                //we have a pixblock, but no image!
                input_image_type_right_has_changed = 1;   /// ?????
                input_image_data_right=0;                 /// ?????

            }
            else
            {
                 /// to do : check if input image has changed

                if (cvGemImageRight==0)
                {

                   // retrieve input image size/type and copy into IplImage cvImageSource
                    gemImageSourceRightWidth = input_gem_state_pointer_right->image->image.xsize;
                    gemImageSourceRightHeight = input_gem_state_pointer_right->image->image.ysize;
                    gemImageSourceRightChannels = input_gem_state_pointer_right->image->image.csize;

                  //    post(" create IplImage header");
                    cvImageSourceRight=cvGemImageRight=cvCreateImageHeader(cvSize(gemImageSourceRightWidth,gemImageSourceRightHeight),
                                            IPL_DEPTH_8U,gemImageSourceRightChannels);
                }

                // reload source image if dirty flag is set
                if (input_gem_state_pointer_right->image->newimage)
                {
                    // reload cvGemImage
                    cvImageSourceRight=cvGemImageRight;
                    // disconnect cvlibImagesource pointer from any eventual cvImage IplImage
                    pcvImageSourceRight=0;

                    /// TO DO : replace with call to virtual function "right_image_has_changed"
                    // signals that right input image has changed
                    cvImageSourceRight_has_changed=1;

                    // retrieve input image size/type and copy into IplImage cvImageSource
                    gemImageSourceRightWidth = cvImageSourceRight->width = input_gem_state_pointer_right->image->image.xsize;
                    gemImageSourceRightHeight = cvImageSourceRight->height = input_gem_state_pointer_right->image->image.ysize;

                    gemImageSourceRightChannels = cvImageSourceRight->nChannels = input_gem_state_pointer_right->image->image.csize;

                    cvImageSourceRight->widthStep=4*int((gemImageSourceRightWidth * gemImageSourceRightChannels+3)/4);

                    cvImageSourceRight->imageData = (char*)input_gem_state_pointer_right->image->image.data;
                    cvImageSourceRight->imageSize = gemImageSourceRightWidth * gemImageSourceRightHeight * gemImageSourceRightChannels;
                    cvImageSourceRight->origin=1-input_gem_state_pointer_right->image->image.upsidedown;

                     // encode colorspace into IplImage struct
                    cvlib_setIplImageColorspace(cvImageSourceRight,input_gem_state_pointer_right->image->image.format);

                    // backup cvGemImage
                    cvGemImageRight=cvImageSourceRight;

                    /// output_dirty_flag not necessary here : should be handled
                    /// by derived class
                    output_dirty_flag = 1;   // mark processing to be done
                }
            }
        }

    }
}

