#ifndef INCLUDE_cvlib_ImageFilter_2_1_H_
#define INCLUDE_cvlib_ImageFilter_2_1_H_

/*
cvlib : flext-based opencv librairy (c) 2009 by jy gratius
based on flext layer

Flext Copyright (c) 2002,2003 Thomas Grill (xovo@gmx.net)
For information on usage and redistribution, and for a DISCLAIMER OF ALL
WARRANTIES, see the file, "license.txt," in this distribution.

-------------------------------------------------------------------------

*/

// opencv headers

#include "cv.h"
#include "highgui.h"



#include <flext.h>

// check for appropriate flext version
#if !defined(FLEXT_VERSION) || (FLEXT_VERSION < 400)
#error You need at least flext version 0.4.0
#endif

#include "cvlib_ImageFilter_1_1.h"
// -------------------------------------------------------------------------------------
// Define the base class cvlib_ImageFilter_2_1
// Note that you don't have to instantiate the base class (with FLEXT_NEW or variants)

class cvlib_ImageFilter_2_1:
	// inherit from cvlib_ImageFilter_1_1 class
	public cvlib_ImageFilter_1_1
{
	// obligatory flext header (class name,base class name)
	FLEXT_HEADER(cvlib_ImageFilter_2_1,cvlib_ImageFilter_1_1)

public:
	// constructor
	cvlib_ImageFilter_2_1();



protected:
    // DESTRUCTOR
    virtual ~cvlib_ImageFilter_2_1();

     void process_cvImage_right_inlet(int sid);         // process when cvImage tag received on right inlet

   void process_gem_state_right_inlet(int argc, t_atom *argv);// process when gem_state pointer received on right inlet

                            // routing, according to nb of channels and colorspace



    IplImage *cvGemImageRight;

    IplImage *cvImageSourceRight;

    IplImage **pcvImageSourceRight;

  int cvImageSourceRight_has_changed;


private:

     int gemImageSourceRightHeight;
    int gemImageSourceRightWidth;
    int gemImageSourceRightChannels;


    int cvImageSourceRightSID;
    int cvImageSourceRightColorModel;



    GemState *input_gem_state_pointer_right;

    char * input_image_data_right;

    int input_image_type_right_has_changed;/// not used


    // right inlet callback
    FLEXT_CALLBACK_I(process_cvImage_right_inlet)
    FLEXT_CALLBACK_G(process_gem_state_right_inlet)
};


// end of #ifndef statement
#endif
