
#include "cvlib_approx_poly.h"
#define CVLIB_DEBUG post


// CONSTRUCTOR
cvlib_approx_poly::cvlib_approx_poly(int argc,t_atom *argv)
    {
        AddInAnything();
           AddInInt();
        AddOutAnything();
        AddOutFloat();
        FLEXT_ADDMETHOD_I(0,"cvContours",process_cvContours);  // register method for tag "cvContours" and int argument
        FLEXT_ADDMETHOD(1,set_tolerance);
    //     FLEXT_ADDBANG(0,bang);  // register method for bang

    // create storage
        storage = cvCreateMemStorage(0);

    // create contour
        cvSeqSID= cvlib_createHeader(CVLIB_TYPE_CONTOUR,CVLIB_STATUS_EXTERNAL_POINTER);

        tolerance = 0.01;
    // argument extraction
     /*   if(argc >= 1)
            if  (IsFloat(argv[0]))
                set_iterations(GetInt(argv[0]));  */
    }

// DESTRUCTOR
cvlib_approx_poly::~cvlib_approx_poly()
    {
        cvlib_freeHeader(cvSeqSID);
     // free storage
        cvReleaseMemStorage(&storage);
    }


void cvlib_approx_poly::set_tolerance(float f)
{
    tolerance=max(f,0);
 }

/*void cvlib_approx_poly::bang()
{
    if (cvImageSourceSID>=0)
        process_cvImage(cvImageSourceSID);
}*/

void cvlib_approx_poly::send_cvContourSID()
{
    if (cvSeqSID>=0)
        {
        SETFLOAT(&my_output,cvSeqSID);
        /// Is "cvContours" a good tag choice ?
         ToOutAnything(0,gensym("cvContours"),1,&my_output);
        }
}



void cvlib_approx_poly::process_cvContours(int i)
{


   if (cvlib_get_type(i)==CVLIB_TYPE_CONTOUR)
    {
       contours=(CvSeq*)cvlib_get_pdata(i);


  //    CVLIB_DEBUG("approxpoly: pointer= %d", p_contours);
     //   /*           cvZero( cvImageSource );
        approximated_contours=approximated_contours_head=0;
        int  count=0;
    //    CVLIB_DEBUG("Entrant dans .....while(%d)",contours);
        while (contours)
        {

            count++;
            //     CVLIB_DEBUG("ApproxPoly-iteration %d",count);
            if (tolerance< 1)
                result = cvApproxPoly( contours, sizeof(CvContour), storage,
                   CV_POLY_APPROX_DP, cvContourPerimeter(contours)*tolerance, 0 );
            else
                result = cvApproxPoly( contours, sizeof(CvContour), storage,
                   CV_POLY_APPROX_DP, tolerance, 0 );

             // copy CV_SEQ_FLAG_HOLE
            result->flags|=contours->flags & CV_SEQ_FLAG_HOLE;
            // store result in approximated_contours sequence

            /// TO DO : add matching criteria here (such as min size, etc...)
            //is a external or internal contour ?
          // the test is : (contour->flags & CV_SEQ_FLAG_HOLE)

            if (count==1)
                {
                // first occurence
                approximated_contours_head=result;
                approximated_contours=result;
                }
            else
                {
                    approximated_contours->h_next=result;
                    approximated_contours=result;
                }

    //      cvDrawContours( cvImageSource, result, CV_RGB(255, 255, 255 ), CV_RGB(255, 255, 255 ), 0, CV_FILLED, 8 );
            contours = contours->h_next;
      //    CVLIB_DEBUG("bouclant..while(%d)",contours);
        }
   //     CVLIB_DEBUG("sortant de..while(%d)",contours);

            // output found_contours
            ToOutInt(1,count);

            // set instance pointer to contours
            cvlib_set_pdata(cvSeqSID,approximated_contours_head);

            // send cv contour SID
            send_cvContourSID();


    }

          // clear memory storage - reset free space position
     cvClearMemStorage(storage);
}


FLEXT_LIB_V("cvApproxPoly cvApproxContours",cvlib_approx_poly);  // 2 aliases



// cvApproxContours
