
#include "cvlib_canny.h"
// CONSTRUCTOR
cvlib_canny::cvlib_canny(int argc,t_atom *argv)
    {

//        input_format_convert(CVT_BGRA2GRAY+CVT_RGBA2GRAY+CVT_RGB2GRAY+CVT_BGR2GRAY);
        // add inlets for cv parameters
        AddInInt();
        AddInInt();
        AddInInt();

        // link inlets to corresponding methods
        FLEXT_ADDMETHOD(1,set_threshold1);
        FLEXT_ADDMETHOD(2,set_threshold2);
        FLEXT_ADDMETHOD(3,set_aperture_size);

        // set cvCanny default values
        aperture_size=3;
        threshold1= 50;
        threshold2= 60;

        // replace cvCanny default values by creation arguments
        if(argc >= 1)
            if  (IsFloat(argv[0]))
                set_threshold1(GetInt(argv[0]));
        if(argc >= 2)
            if  (IsFloat(argv[1]))
                set_threshold2(GetInt(argv[1]));
        if(argc >= 3)
            if  (IsFloat(argv[2]))
            {
                set_aperture_size(GetInt(argv[2]));
            }


    }

// DESTRUCTOR
cvlib_canny::~cvlib_canny()
    {
// free extra ressources

    }


void cvlib_canny::set_threshold1(int value)
{
    threshold1=max(0, value);
    // force image processing on next gemstate
    output_dirty_flag=1;
}

void cvlib_canny::set_threshold2(int value)
{
    threshold2=max(0, value);
    // force image processing on next gemstate
    output_dirty_flag=1;
}

void cvlib_canny::set_aperture_size(int value)
{
    if ((value == 3)||(value == 5)||(value == 7))
        aperture_size= value;
    // force image processing on next gemstate
     output_dirty_flag=1;
}

//cvCanny only works on 1Channel images :
// only override process_1channel_image() function

int cvlib_canny::process_1channel_image(IplImage * &Source, IplImage * &Dest)
{

    int result=cvlib_prepareIplImage(&Dest, Source->width, Source->height, 1);
    // prepare dest image with same size as original, and 1 channel
    if (result)
    {
        cvCanny((const IplImage*)Source, Dest,threshold1,threshold2, aperture_size);
        return result;
    }
    else
    {
        cvlib_error("error (re)creating target image");
        return CVLIB_FAILED;
    }
}

int cvlib_canny::process_4channels_image(IplImage * &Source, IplImage * &Dest)
    {
        cvlib_prepareIplImage(&cvImageTemp, Source->width, Source->height, 1);
        cvCvtColor(Source, cvImageTemp, CV_BGRA2GRAY);
        process_1channel_image(cvImageTemp,cvImageTemp2);
        int result=cvlib_prepareIplImage(&Dest, Source->width, Source->height, 4);
        if (result)
            {
            cvZero( Dest );
    // copy edge points
            cvCopy( Source, Dest, cvImageTemp2 );
            }
          //  cvCvtColor(cvImageTemp2,Dest,CV_GRAY2BGRA);
        return result;
    }




FLEXT_LIB_V("cvCanny",cvlib_canny);


