
#include "cvlib_circle.h"
// CONSTRUCTOR
cvlib_circle::cvlib_circle()
    {

        nb_of_circles=0;
        // add inlets for cv parameters
        AddInInt();  // x
        AddInInt();     // y

        AddInInt(); // r


        // link inlets to corresponding methods
        FLEXT_ADDMETHOD(1,set_x);
        FLEXT_ADDMETHOD(2,set_y);
        FLEXT_ADDMETHOD(3,set_r);
        FLEXT_ADDMETHOD_I(0, gensym("width"), set_width);
        FLEXT_ADDMETHOD_(0, gensym("color"), set_color);


        // set  default values
        x=y=r=0;
        width=1;
        color_r=255;
        color_g=255;
        color_b=255;


    /*    // replace cvdilate default values by creation arguments
        if(argc >= 1)
            if  (IsFloat(argv[0]))
                set_iterations(GetInt(argv[0]));
*/

    }

// DESTRUCTOR
cvlib_circle::~cvlib_circle()
    {
// free extra ressources

    }


void cvlib_circle::set_x(int i)
{
    x=i;
    nb_of_circles++;
    if(nb_of_circles<=nb_max_of_circles)
    {
        circles[nb_of_circles].center=cvPoint(x,y);
        circles[nb_of_circles].r=r;
        circles[nb_of_circles].width=width;
        circles[nb_of_circles].color=CV_RGB(color_r,color_g,color_b);
        // force image processing on next gemstate
    output_dirty_flag=1;
    }
}

void cvlib_circle::set_y(int i)
{
    y=i;
}

void cvlib_circle::set_r(int i)
{
    r=max(0,i);
        // force image processing on next gemstate
   // output_dirty_flag=1;
}

void cvlib_circle::set_width(int i)
{
   width=min(255,max(-1,i));
        // force image processing on next gemstate
   // output_dirty_flag=1;
}

void cvlib_circle::set_color(int argc, t_atom *argv)
{
     if(argc == 3)
            if  (IsFloat(argv[0])&&IsFloat(argv[1])&&IsFloat(argv[2]))
            {
                color_r=max(0,min(255,GetInt(argv[0])));
                color_g=max(0,min(255,GetInt(argv[1])));
                color_b=max(0,min(255,GetInt(argv[2])));
                // force image processing on next gemstate
                //output_dirty_flag=1;
                return;
            }
    cvlib_error("cvCircle : invalid color arguments");
}








//cvCircle works on any Channel images :
// only override process_default_image() function

int cvlib_circle::process_default_image(IplImage *&Source, IplImage * &Dest)
{
    //cvReleaseImage(&cvImageDest);
    int result=cvlib_prepareIplImage(&Dest, Source->width, Source->height, Source->nChannels);
    cvCopyImage(Source,Dest);
    // prepare dest image with same size as original, and 1 channel
    if (result)
    {
        for(int i=0;i<nb_of_circles;i++)
            cvCircle( Dest, circles[i].center, circles[i].r, circles[i].color, circles[i].width, 8,0);

       // reset for next iteration
        nb_of_circles=0;
        return result;
    }
    else
    {
        cvlib_error("error (re)creating target image");
        return CVLIB_FAILED;
    }
}

FLEXT_LIB("cvDrawCircle",cvlib_circle);


