
#include "cvlib_contours_bounding_rect.h"
#define CVLIB_DEBUG post


// CONSTRUCTOR
cvlib_contours_bounding_rect::cvlib_contours_bounding_rect(int argc,t_atom *argv)
    {
        AddInAnything();  // cvContours inlet

        AddOutAnything();
      //  AddOutFloat();
        FLEXT_ADDMETHOD_I(0,"cvContours",process_cvContours);  // register method for tag "cvContours" and int argument
        //
        matrix_output_mode=0;

       if(argc >= 1)
            if  (IsFloat(argv[0]))
                matrix_output_mode=(GetInt(argv[0]));
    }

// DESTRUCTOR
cvlib_contours_bounding_rect::~cvlib_contours_bounding_rect()
    {

    }


void cvlib_contours_bounding_rect::process_cvContours(int i)
{
    int nbofsegments=0;

   if (cvlib_get_type(i)==CVLIB_TYPE_CONTOUR)
    {
       contours=(CvSeq*)cvlib_get_pdata(i);

        int  count=0;

        while (contours)
        {
            rect = cvContourBoundingRect( contours, 1);
            if (matrix_output_mode) // prepare result in matrix output mode
            {

                SETFLOAT(&my_output.results[count][0],rect.x);
                SETFLOAT(&my_output.results[count][1],rect.y);
                SETFLOAT(&my_output.results[count][2],rect.width);
                SETFLOAT(&my_output.results[count][3],rect.height);
            }
            else
            {
                // send result in instant mode
                SETFLOAT(&result[0], count);
                SETFLOAT(&result[1],rect.x);
                SETFLOAT(&result[2],rect.y);
                SETFLOAT(&result[3],rect.width);
                SETFLOAT(&result[4],rect.height);

                ToOutList(0,5, result);
            }
            count++;
            contours = contours->h_next;
            if (count > CVLIB_MAX_CONTOURS)
                continue;
        }
        if (matrix_output_mode)
        {
            SETFLOAT(&my_output.ncol,4);
            SETFLOAT(&my_output.nrow,count);

            // post("count=%d",count);
            if(count)
                ToOutAnything(0,gensym("matrix"),2+(count*4),&my_output.nrow);
        }
    }

}


FLEXT_LIB_V("cvContoursBoundingRect",cvlib_contours_bounding_rect);



// cvApproxContours
