
#include "cvlib_contours_convex_hull.h"
#define CVLIB_DEBUG post


// CONSTRUCTOR
cvlib_contours_convex_hull::cvlib_contours_convex_hull(int argc,t_atom *argv)
    {
        AddInAnything();

        AddOutAnything();

        FLEXT_ADDMETHOD_I(0,"cvContours",process_cvContours);  // register method for tag "cvContours" and int argument


    // create storage
        storage = cvCreateMemStorage(0);

    // create contour
        cvSeqSID= cvlib_createHeader(CVLIB_TYPE_CONTOUR,CVLIB_STATUS_EXTERNAL_POINTER);



    }

// DESTRUCTOR
cvlib_contours_convex_hull::~cvlib_contours_convex_hull()
    {
        cvlib_freeHeader(cvSeqSID);
     // free storage
        cvReleaseMemStorage(&storage);
    }




void cvlib_contours_convex_hull::send_cvContourSID()
{
    if (cvSeqSID>=0)
        {
        SETFLOAT(&my_output,cvSeqSID);

         ToOutAnything(0,gensym("cvContours"),1,&my_output);
        }
}



void cvlib_contours_convex_hull::process_cvContours(int i)
{
  /*   if(convex_seq!=0)
        {
            convex_seq=0;
            cvClearMemStorage(storage);
        }
*/
    int contours_count=0;
    int* hull;
    int hullsize;
    CvPoint* PointArray;
    CvPoint* ConvexPointArray;

   if (cvlib_get_type(i)==CVLIB_TYPE_CONTOUR)
    {
        contours=(CvSeq*)cvlib_get_pdata(i);

        convex_contours=convex_contours_head=0;
        while (contours)
        {
            contours_count++;
            int count=contours->total;

            // Alloc memory for contour point set.

            PointArray = (CvPoint*)malloc(count * sizeof(CvPoint) );

            // Alloc memory for indices of convex hull vertices.
            hull = (int*)malloc(sizeof(int) * count);

            // Get contour point set.
            cvCvtSeqToArray(contours, PointArray, CV_WHOLE_SEQ);

            // Find convex hull for curent contour.
            cvConvexHull( PointArray,
                      count,
                      NULL,
                      CV_COUNTER_CLOCKWISE,
                      hull,
                      &hullsize);
              // creating cvseq contour from convex hull for further purposes (cvPointPolygonTest)
            ConvexPointArray = (CvPoint*)malloc(sizeof(CvPoint)*hullsize);
            CvSeqWriter writer;
            cvStartWriteSeq( CV_SEQ_ELTYPE_POINT|CV_SEQ_KIND_CURVE|CV_SEQ_FLAG_CLOSED, sizeof(CvSeq), sizeof(CvPoint), storage, &writer );
            for( int ii=0;ii<hullsize; ii++ )
            {
                CV_WRITE_SEQ_ELEM( PointArray[hull[ii]], writer );
            }
            convex_seq = cvEndWriteSeq( &writer );

 // store result in approximated_contours sequence
            if (contours_count==1)
            {
                // first occurence : store in head of dynamic structure
                convex_contours_head=convex_seq;
                convex_contours=convex_seq;

            }
            else
            {
                // link to dynamic structure
                convex_contours->h_next=convex_seq;
                // change current poointer
                convex_contours=convex_seq;

            }
            // go to next contour
            contours = contours->h_next;

                  // Free memory.
            free(PointArray);
            free(ConvexPointArray);
            free(hull);

        }

        // set instance pointer to contours
        cvlib_set_pdata(cvSeqSID,convex_contours_head);
        // send cv contour SID
        send_cvContourSID();
    }

          // clear memory storage - reset free space position
     cvClearMemStorage(storage);

}


FLEXT_LIB_V("cvContoursConvexHull",cvlib_contours_convex_hull);



// cvApproxContours
