/*-----------------------------------------------------------------
LOG
    GEM - Graphics Environment for Multimedia

    Contours Bounding Rectangle detection

    Copyright (c) 1997-1999 Mark Danks. mark@danks.org
    Copyright (c) Gnther Geiger. geiger@epy.co.at
    Copyright (c) 2001-2002 IOhannes m zmoelnig. forum::fr::umlute. IEM. zmoelnig@iem.kug.ac.at
    Copyright (c) 2002 James Tittle & Chris Clepper
    For information on usage and redistribution, and for a DISCLAIMER OF ALL
    WARRANTIES, see the file, "GEM.LICENSE.TERMS" in this distribution.

-----------------------------------------------------------------*/

#ifndef INCLUDE_cvlib_contours_convexity2_H_
#define INCLUDE_cvlib_contours_convexity2_H_


#include "cvlib_ImageFilter_1_1.h"

#include <stdio.h>
#define MAX_MARKERS 100

/*-----------------------------------------------------------------
-------------------------------------------------------------------
CLASS
    cvlib_contours_convexity2

    Contours Bounding Rectangle detection

KEYWORDS
    pix

DESCRIPTION

-----------------------------------------------------------------*/
class cvlib_contours_convexity2:
	public cvlib_ImageFilter_1_1
{
	// obligatory flext header, inherit from cvlib_ImageFilter_1_1

	FLEXT_HEADER(cvlib_contours_convexity2,cvlib_ImageFilter_1_1)
public:
    //////////
    // Constructor
    cvlib_contours_convexity2();

protected:
    //////////
    // Destructor
    virtual ~cvlib_contours_convexity2();

    //////////
    // Do the processing

   // 	virtual void 	processRGBAImage(imageStruct &image);
    virtual int	process_RGBA_image(IplImage * &Source, IplImage * &Dest);

    // 	virtual void 	processRGBImage(imageStruct &image);
    virtual int process_RGB_image(IplImage * &Source, IplImage * &Dest);



    virtual int process_1channel_image(IplImage * &Source, IplImage * &Dest);

     	// Set the new edge threshold
    void    floatMinAreaMess(float minarea);
    void    floatMaxAreaMess(float maxarea);
    void    setMargin(int i);

       	// The new minimal/maximal area
	int 	minarea;
	int 	maxarea;

	// to detect changes in the image size
	int 	comp_xsize;
	int		comp_ysize;

    int margin;

  	/////////
	// IplImage needed
    	IplImage 	*rgb, *orig, *gray,*grayIn, *grayOut;

    CvMemStorage* stor01;
    CvMemStorage* stor02;
    CvMemStorage* stor03;
    CvMemStorage* stor04;
    CvMemStorage* stor05;

    CvSeq* defects;
    CvSeq* contours;
    CvSeq* convex_seq;
    CvSeq* approx_result;
    CvSeq* seqhull;




private:
    FLEXT_CALLBACK_F(floatMinAreaMess)
    FLEXT_CALLBACK_F(floatMaxAreaMess)
    FLEXT_CALLBACK_I(setMargin)
//    FLEXT_CALLBACK_I(process_cvContours)

};

// for header file
#endif

