

#include "cvlib_contours_convexity_defects.h"
#include <stdio.h>


/////////////////////////////////////////////////////////
//
// cvlib_contours_convexity_defects
//
/////////////////////////////////////////////////////////
// Constructor
//
/////////////////////////////////////////////////////////
cvlib_contours_convexity_defects :: cvlib_contours_convexity_defects(int argc,t_atom *argv)
{
  AddInAnything();
  AddInFloat();

  /////////////////////////////////////////////////////////
// static member function
//
/////////////////////////////////////////////////////////

    sorted_defects.reserve(200);
    FLEXT_ADDMETHOD_I(0,gensym("margin"),set_Margin);
    FLEXT_ADDMETHOD(1,set_MaxConvexDefects);
    FLEXT_ADDMETHOD_I(0,"cvContours",process_cvContours);  // register method for tag "cvContours" and int argument

    if ((argc==1)&&(IsFloat(argv[0])))
        set_MaxConvexDefects(GetFloat(argv[0]));



    AddOutList();    // deepest convexity defect point

    AddOutList();   // number convexity defects
    AddOutList();    // m_dataout

 //   minarea = 1;
//  maxarea = 320*240;
    margin=15;

    stor01 = cvCreateMemStorage(0);
    stor02 = cvCreateMemStorage(0);
    stor03 = cvCreateMemStorage(0);
    stor04 = cvCreateMemStorage(0);
   stor05 = cvCreateMemStorage(0);

    defects=0;
    contours=0;
    convex_seq=0;
    approx_result=0;
    seqhull=0;

}

/////////////////////////////////////////////////////////
// Destructor
//
/////////////////////////////////////////////////////////
cvlib_contours_convexity_defects :: ~cvlib_contours_convexity_defects()
{
    	//Destroy cv_images to clean memory
    cvReleaseMemStorage( &stor01 );
    cvReleaseMemStorage( &stor02 );
    cvReleaseMemStorage( &stor03 );
    cvReleaseMemStorage( &stor04 );
    cvReleaseMemStorage( &stor05 );
}

bool compare_depth_distance( convexity_point point_A, convexity_point point_B )
{

    return point_A.depth > point_B.depth;
    }


/////////////////////////////////////////////////////////
// processImage
//
/////////////////////////////////////////////////////////


void cvlib_contours_convexity_defects::process_cvContours(int i)
{
convexity_point my_convex_point;


    int nbofsegments=0;

// clear mem storage
    if(contours!=0)
        {
            contours=0;
            cvClearMemStorage(stor01);
        }
    if(approx_result!=0)
        {
            approx_result=0;
            cvClearMemStorage(stor02);
        }

    if(defects!=0)
        {
            defects=0;
            cvClearMemStorage(stor03);
        }

    if(convex_seq!=0)
        {
            convex_seq=0;
            cvClearMemStorage(stor04);
        }
    if(seqhull!=0)
        {
            seqhull=0;
            cvClearMemStorage(stor05);
        }

    if (cvlib_get_type(i)==CVLIB_TYPE_CONTOUR)
    {
        contours=(CvSeq*)cvlib_get_pdata(i);

        int  count=0;

        while (contours)
        {
            count=contours->total;
            // post ("count=%d", count);
            // Alloc memory for contour point set.

            PointArray = (CvPoint*)malloc(count * sizeof(CvPoint) );

            // Alloc memory for indices of convex hull vertices.
            hull = (int*)malloc(sizeof(int) * count);

            // Get contour point set.
            cvCvtSeqToArray(contours, PointArray, CV_WHOLE_SEQ);

            // Find convex hull for curent contour.
            cvConvexHull( PointArray,count,NULL,CV_COUNTER_CLOCKWISE,hull,&hullsize);

            // Find convex hull for current contour.
            // This required for cvConvexityDefects().
            seqhull = cvConvexHull2(contours,stor05,CV_COUNTER_CLOCKWISE,0);

     //   post("hullsize=%d, seqhull->total=%d",hullsize, seqhull->total);/// the same

       // creating cvseq contour from convex hull for further purposes (cvPointPolygonTest)
            ConvexPointArray = (CvPoint*)malloc(sizeof(CvPoint)*hullsize);
            CvSeqWriter writer;
            cvStartWriteSeq( CV_SEQ_ELTYPE_POINT|CV_SEQ_KIND_CURVE|CV_SEQ_FLAG_CLOSED, sizeof(CvSeq), sizeof(CvPoint), stor04, &writer );
            for( int ii=0;ii<hullsize; ii++ )
            {
                CV_WRITE_SEQ_ELEM( PointArray[hull[ii]], writer );
            }
            convex_seq = cvEndWriteSeq( &writer );
        //  post("hullsize=%d", hullsize);
        // This required for cvConvexityDefects().
        // Otherwise cvConvexityDefects() falled.

            if( hullsize >= 4 )   ///  >=3 ???
            {
                // Find defects of convexity of current contours.
                defects = cvConvexityDefects(contours,seqhull,stor03);

                int number_of_defects = defects->total; // defect amount
                //   post("defects->total=%d",defects->total);

                // Alloc memory for defect set.
                defectArray = (CvConvexityDefect*)malloc(sizeof(CvConvexityDefect) * number_of_defects);
                   if(number_of_defects > 0)
                {
                    // convert defect set to Array, in order to do polygontest.
                    cvCvtSeqToArray(defects,defectArray, CV_WHOLE_SEQ);
                    int matched_defects=0;
                    for(i=0; i<number_of_defects; i++)
                    {
                        // do polygon test to  see if depth_point is not part of contour
                        depth_point32F.x=defectArray[i].depth_point->x;
                        depth_point32F.y=defectArray[i].depth_point->y;
                        depth_distance= (cvPointPolygonTest(convex_seq,depth_point32F,1)>margin);
                        if(depth_distance)
                        {
                            matched_defects++;
                            depth_distance*=sqrt((float)((defectArray[i].start->x-defectArray[i].depth_point->x)*(defectArray[i].start->x-defectArray[i].depth_point->x)
                                +
                                (defectArray[i].start->y-defectArray[i].depth_point->y)*(defectArray[i].start->y-defectArray[i].depth_point->y)
                                +
                                (defectArray[i].end->x-defectArray[i].depth_point->x)*(defectArray[i].end->x-defectArray[i].depth_point->x)
                                +
                                (defectArray[i].end->y-defectArray[i].depth_point->y)*(defectArray[i].end->y-defectArray[i].depth_point->y)));
                            my_convex_point.x=depth_point32F.x;
                            my_convex_point.y=depth_point32F.y;
                            my_convex_point.depth=depth_distance;
                            sorted_defects.push_back(my_convex_point);
                        }

                    }

                    // Sort defectArray
                    std::sort( sorted_defects.begin(), sorted_defects.end(),compare_depth_distance);

                    int j=min(min(max_convex_defects,number_of_defects),matched_defects);
                    // output number of convexity defects
                    ToOutFloat( 2, j);
                    // output sorted convexity defects
                    for(i=0; i<j; i++)
                    {
                        SETFLOAT(&rlist[0], i);
                        SETFLOAT(&rlist[1], sorted_defects[i].x);
                        SETFLOAT(&rlist[2], sorted_defects[i].y);
                        SETFLOAT(&rlist[3], sorted_defects[i].depth);
                        ToOutList(1, 4, rlist);
                    }
                //j++;
                }
        // Free memory.
                free(defectArray);
                sorted_defects.clear();
            }
            // Free memory.
            free(PointArray);
            free(ConvexPointArray);
            free(hull);

            // go to next contour
            contours = contours->h_next;
        }
    }
}



void cvlib_contours_convexity_defects :: set_Margin (int i)
{
  margin=i;
}
void cvlib_contours_convexity_defects ::set_MaxConvexDefects (int i)
{
  max_convex_defects=i;
}
FLEXT_LIB_V("cvContoursConvexityDefects",cvlib_contours_convexity_defects);
