
#ifndef INCLUDE_cvlib_contours_convexity_defects_H_
#define INCLUDE_cvlib_contours_convexity_defects_H_

#include "cvlib.h"
#include <stdio.h>
#define MAX_MARKERS 100

typedef struct convexity_point {
    int x;
    int y;
    float depth;
    };
/*-----------------------------------------------------------------
-------------------------------------------------------------------
CLASS
    cvlib_contours_convexity_defects

    Contours convexity defects detection

KEYWORDS


DESCRIPTION

-----------------------------------------------------------------*/
class cvlib_contours_convexity_defects:
	public flext_base
{
	// obligatory flext header, inherit from cvlib_base
	FLEXT_HEADER(cvlib_contours_convexity_defects,flext_base)
public:
    //////////
    // Constructor
    cvlib_contours_convexity_defects(int argc,t_atom *argv);
    // Destructor
   ~cvlib_contours_convexity_defects();

protected:
    //////////

    int margin;
    int max_convex_defects;
    CvSeq* convex_seq;
    CvConvexityDefect* defectArray;
    void process_cvContours (int i);

    void set_Margin(int i);
    void set_MaxConvexDefects(int i);
    CvMemStorage* stor01;
    CvMemStorage* stor02;
    CvMemStorage* stor03;
    CvMemStorage* stor04;
    CvMemStorage* stor05;

    CvSeq* defects;
    CvSeq* contours;

    CvSeq* approx_result;
    CvSeq* seqhull;
    CvPoint2D32f depth_point32F;
    t_atom rlist[4];


    std::vector<convexity_point> sorted_defects;
    int* hull;
    int hullsize;
    CvPoint* PointArray;
    CvPoint* ConvexPointArray;
    float depth_distance;

private:
    FLEXT_CALLBACK_I(process_cvContours)
    FLEXT_CALLBACK_I(set_Margin)
    FLEXT_CALLBACK_I(set_MaxConvexDefects)
};

// for header file
#endif

