#ifndef INCLUDE_cvlib_contours_get_H_
#define INCLUDE_cvlib_contours_get_H_


#include "cvlib.h"
#include <stdio.h>


class cvlib_contours_get:
	public flext_base
{
	// obligatory flext header, inherit from cvlib_base
	FLEXT_HEADER(cvlib_contours_get,flext_base)
public:
    cvlib_contours_get(int argc,t_atom *argv);
    ~cvlib_contours_get();


protected:
    void process_cvContours (int i);

// feature extraction functions
    void get_Area(CvSeq* contour,int feature_outlet);
    void get_BoundingRect(CvSeq* contour,int feature_outlet);
    void get_Centroids(CvSeq* contour,int feature_outlet);
    void get_DominantPoints(CvSeq* contour,int feature_outlet);
    void get_FitEllipse(CvSeq* contour,int feature_outlet);
    void get_Flags(CvSeq* contour,int feature_outlet);
    void get_HuMoments(CvSeq* contour,int feature_outlet);
    void get_LogHuMoments(CvSeq* contour,int feature_outlet);
    void get_IsConvex(CvSeq* contour,int feature_outlet);
    void get_MinAreaRect(CvSeq* contour,int feature_outlet);
    void get_Nothing(CvSeq* contour,int feature_outlet);
    void get_Perimeter(CvSeq* contour,int feature_outlet);
    void get_SegmentCount(CvSeq* contour,int feature_outlet);

    typedef  void  (cvlib_contours_get::*pt2Member)(CvSeq* contour,int feature_outlet);
    // array of pointers to feature extraction functions
    pt2Member  funcArr[10];

private:

    CvSeq* contours;
    int nb_of_features;


// variables used by feature extraction functions
    CvRect rect;
    CvBox2D min_area_rect;
    t_atom result[8];
    float moment_value[7];
    CvMoments moments;
    CvHuMoments HuMoments;
    FLEXT_CALLBACK_I(process_cvContours)
};



// end of #ifndef statement
#endif

