
#include "cvlib_contours_hu_moments.h"
#define CVLIB_DEBUG post


// CONSTRUCTOR
cvlib_contours_hu_moments::cvlib_contours_hu_moments(int argc,t_atom *argv)
    {
        AddInAnything();  // cvContours inlet

        AddOutAnything();
      //  AddOutFloat();
        FLEXT_ADDMETHOD_I(0,"cvContours",process_cvContours);  // register method for tag "cvContours" and int argument
        //
        matrix_output_mode=0;
        log_output_mode=0;

       if(argc >= 1)                // flags
            if  (IsFloat(argv[0]))
            {
                matrix_output_mode=((GetInt(argv[0]))&1);
                log_output_mode=((GetInt(argv[0]))&2);
            }
    }

// DESTRUCTOR
cvlib_contours_hu_moments::~cvlib_contours_hu_moments()
    {

    }


void cvlib_contours_hu_moments::process_cvContours(int i)
{
    int nbofsegments=0;
    float moment_value[7];

   if (cvlib_get_type(i)==CVLIB_TYPE_CONTOUR)
    {
       contours=(CvSeq*)cvlib_get_pdata(i);

        int  count=0;

        while (contours)
        {
            cvContourMoments(contours,&moments);
            cvGetHuMoments(&moments,&HuMoments);


            moment_value[0]=HuMoments.hu1;
            moment_value[1]=HuMoments.hu2;
            moment_value[2]=HuMoments.hu3;
            moment_value[3]=HuMoments.hu4;
            moment_value[4]=HuMoments.hu5;
            moment_value[5]=HuMoments.hu6;
            moment_value[6]=HuMoments.hu7;

            if(log_output_mode)
            {
                float temp;
                for (int k=0;k<7;k++)
                {
                    temp=moment_value[k];
                    moment_value[k]=((2*(temp>0)-1))*log(abs(temp));
                }
            }

            if (matrix_output_mode) // prepare result in matrix output mode
            {
                for (int k=0;k<7;k++)
                    SETFLOAT(&my_output.results[count][k],moment_value[k]);
            }
            else
            {
                // send result in instant mode
                SETFLOAT(&result[0], count);
                for (int k=0;k<7;k++)
                    SETFLOAT(&result[k+1],moment_value[k]);
                ToOutList(0,8, result);
            }
            count++;
            contours = contours->h_next;
            if (count > CVLIB_MAX_CONTOURS)
                continue;
        }
        if (matrix_output_mode)
        {
            SETFLOAT(&my_output.ncol,7);
            SETFLOAT(&my_output.nrow,count);

            // post("count=%d",count);
            if(count)
                ToOutAnything(0,gensym("matrix"),2+(count*7),&my_output.nrow);
        }
    }

}


FLEXT_LIB_V("cvContoursHuMoments",cvlib_contours_hu_moments);



// cvApproxContours
