
#include "cvlib_contours_min_area_rect.h"
#define CVLIB_DEBUG post


// CONSTRUCTOR
cvlib_contours_min_area_rect::cvlib_contours_min_area_rect(int argc,t_atom *argv)
    {
        AddInAnything();  // cvContours inlet

        AddOutAnything();
      //  AddOutFloat();
        FLEXT_ADDMETHOD_I(0,"cvContours",process_cvContours);  // register method for tag "cvContours" and int argument
        //
        matrix_output_mode=0;

       if(argc >= 1)
            if  (IsFloat(argv[0]))
                matrix_output_mode=(GetInt(argv[0]));
    }

// DESTRUCTOR
cvlib_contours_min_area_rect::~cvlib_contours_min_area_rect()
    {

    }


void cvlib_contours_min_area_rect::process_cvContours(int i)
{
    int nbofsegments=0;

   if (cvlib_get_type(i)==CVLIB_TYPE_CONTOUR)
    {
       contours=(CvSeq*)cvlib_get_pdata(i);

        int  count=0;

        while (contours)
        {
            min_area_rect = cvMinAreaRect2( contours, 0);
            if (matrix_output_mode) // prepare result in matrix output mode
            {
                SETFLOAT(&my_output.results[count][0],min_area_rect.center.x);
                SETFLOAT(&my_output.results[count][1],min_area_rect.center.y);
                SETFLOAT(&my_output.results[count][2],min_area_rect.size.width);
                SETFLOAT(&my_output.results[count][3],min_area_rect.size.height);
                SETFLOAT(&my_output.results[count][4],min_area_rect.angle);

            }
            else
            {
                // send result in instant mode
                SETFLOAT(&result[0], count);
                SETFLOAT(&result[1],min_area_rect.center.x);
                SETFLOAT(&result[2],min_area_rect.center.y);
                SETFLOAT(&result[3],min_area_rect.size.width);
                SETFLOAT(&result[4],min_area_rect.size.height);
                SETFLOAT(&result[5],min_area_rect.angle);

                ToOutList(0,6, result);
            }
            count++;
            contours = contours->h_next;
            if (count > CVLIB_MAX_CONTOURS)
                continue;
        }
        if (matrix_output_mode)
        {
            SETFLOAT(&my_output.ncol,5);
            SETFLOAT(&my_output.nrow,count);

            // post("count=%d",count);
            if(count)
                ToOutAnything(0,gensym("matrix"),2+(count*5),&my_output.nrow);
        }
    }

}


FLEXT_LIB_V("cvContoursMinAreaRect",cvlib_contours_min_area_rect);



// cvApproxContours
