#ifndef INCLUDE_cvlib_defines_H_
#define INCLUDE_cvlib_defines_H_



#ifndef CVLIB_VERBOSE
#define CVLIB_VERBOSE 0
#endif
// size of cvlib_pool container
#define CVLIB_POOL_SIZE 1000
// max size of images
#define CVLIB_MAX_IMAGE_WIDTH 3000
#define CVLIB_MAX_IMAGE_HEIGHT 3000
#define CVLIB_MAX_IMAGE_CHANNELS 4
// status of objects
#define CVLIB_STATUS_NULL 0
#define CVLIB_STATUS_HEADER_AND_DATA 1
#define CVLIB_STATUS_DATA_NOT_OWNED 2
#define CVLIB_STATUS_EXTERNAL_POINTER 3
#define CVLIB_STATUS_ERROR 0   /// value to change....

// flags
#define CVLIB_IMAGE_SID_HAS_CHANGED 1
#define CVLIB_IMAGE_SIZE_HAS_CHANGED 2
#define CVLIB_IMAGE_COI_HAS_CHANGED 4
#define CVLIB_IMAGE_DIMENSIONS_HAS_CHANGED 6


// types of objects
#define CVLIB_TYPE_NULL 0
#define CVLIB_TYPE_IPLIMAGE 1
#define CVLIB_TYPE_CONTOUR 2



// verbose state
#if CVLIB_VERBOSE
    #define CVLIB_DEBUG post
#else
    #define CVLIB_DEBUG //
#endif

// sending error message to console and make it trackable in Find Last Error menu
#if FLEXT_SYS == FLEXT_SYS_PD
    #define cvlib_error(message, ...) pd_error(thisHdr(), message, ## __VA_ARGS__)
#else
    #define cvlib_error(message, ...) error(thisHdr(), message, ## __VA_ARGS__)
#endif

// class configuration flags
/*
// supported input types
#define PROCESS_1_CHANNEL 1
#define PROCESS_2_CHANNELS 2
#define PROCESS_3_CHANNELS 4
#define PROCESS_4_CHANNELS 8

// optionnal input conversion preprocessing
#define CVT_BGR2GRAY 1
#define CVT_RGB2GRAY 2
#define CVT_BGRA2GRAY 4
#define CVT_RGBA2GRAY 8

#define CVT_BGR2RGB 16
#define CVT_RGB2BGR 32
#define CVT_BGRA2RGBA 64
#define CVT_RGBA2BGRA 128

#define CVT_BGR2BGRA 256
#define CVT_RGB2RGBA 512
*/
// return functions status
#define CVLIB_OK 1
#define CVLIB_FAILED 0
#define CVLIB_RESIZED 2

//cvlib color encoding
#define CVLIB_RGBA 1
#define CVLIB_RGB 2
#define CVLIB_BGR 3
#define CVLIB_BGRA 4
#define CVLIB_RGB16 4
#define CVLIB_LUMINANCE 5
#define CVLIB_LUMINANCE_ALPHA 6
#define CVLIB_UNSIGNED_BYTE 7

// define max number of contours
#define CVLIB_MAX_CONTOURS 10000


// end of #ifndef statement
#endif
