
#include "cvlib_dilate.h"
// CONSTRUCTOR
cvlib_dilate::cvlib_dilate(int argc,t_atom *argv)
    {


        // add inlets for cv parameters
        AddInInt();


        // link inlets to corresponding methods
        FLEXT_ADDMETHOD(1,set_iterations);


        // set cvDilate default values
        iterations=1;


        // replace cvdilate default values by creation arguments
        if(argc >= 1)
            if  (IsFloat(argv[0]))
                set_iterations(GetInt(argv[0]));


    }

// DESTRUCTOR
cvlib_dilate::~cvlib_dilate()
    {
// free extra ressources

    }


void cvlib_dilate::set_iterations(int i)
{
    iterations=min(64,max(0, i));
        // force image processing on next gemstate
    output_dirty_flag=1;
}



//cvDilate works on any Channel images :
// only override process_default_image() function

int cvlib_dilate::process_default_image(IplImage *&Source, IplImage * &Dest)
{
    //cvReleaseImage(&cvImageDest);
    int result=cvlib_prepareIplImage(&Dest, Source->width, Source->height, Source->nChannels);
    // prepare dest image with same size as original, and 1 channel
    if (result)
    {
        if(result & CVLIB_RESIZED)
            cvSetImageROI(Dest, cvGetImageROI(Source));
        cvDilate( Source, Dest, 0,iterations );
        return result;
    }
    else
    {
        cvlib_error("error (re)creating target image");
        return CVLIB_FAILED;
    }
}

FLEXT_LIB_V("cvDilate",cvlib_dilate);


