
#include "cvlib_draw_contours.h"
#define CVLIB_DEBUG post


// CONSTRUCTOR
cvlib_draw_contours::cvlib_draw_contours(int argc,t_atom *argv)
    {
        AddInAnything();   // inlet for cvContour

        FLEXT_ADDMETHOD_I(1,"cvContours",set_cvContours);  // register method for tag "cvContours" and int argument

        FLEXT_ADDMETHOD_I(0,"thickness",set_thickness);  // register method for tag "cvImage" and int argument
        FLEXT_ADDMETHOD_(0,"color",set_color);  // register method for tag "color" and variable arguments
        FLEXT_ADDMETHOD_(0,"int_color",set_int_color);  // register method for tag "color" and variable arguments
        FLEXT_ADDMETHOD_(0,"ext_color",set_ext_color);  // register method for tag "color" and variable arguments


        contours_to_draw=0;
        thickness=1;

        outer_contour_color=inner_contour_color=CV_RGB(255,255,255);


    }

// DESTRUCTOR
cvlib_draw_contours::~cvlib_draw_contours()
    {
    }

int cvlib_draw_contours::process_default_image(IplImage *&Source, IplImage * &Dest)
{
       int result=cvlib_prepareIplImage(&Dest, Source->width, Source->height, Source->nChannels);
    cvCopyImage(Source,Dest);
    // prepare dest image with same size as original, and 1 channel
    if (result)
    while (contours_to_draw)
    {
        /*cvDrawContours args : ( CvArr *img, CvSeq* contour,
        CvScalar external_color, CvScalar hole_color,
        int max_level, int thickness=1,
        int line_type=8 )*/

        cvDrawContours( Dest, contours_to_draw, outer_contour_color, inner_contour_color, 0, thickness, 8 );
        contours_to_draw=contours_to_draw->h_next;
    }
    return result;
}




void cvlib_draw_contours::set_cvContours(int i)
{
   if (cvlib_get_type(i)==CVLIB_TYPE_CONTOUR )
        contours_to_draw=(CvSeq*)cvlib_get_pdata(i);
}




void cvlib_draw_contours::set_thickness(int i)
{
    thickness=i;
}

void cvlib_draw_contours::set_color (int argc,t_atom *argv)
{
    if (argc==3)
        if (IsFloat(argv[0])&&IsFloat(argv[1])&&IsFloat(argv[2]))
           inner_contour_color=outer_contour_color=CV_RGB(max(0,min(255,GetInt(argv[0]))),
                                        max(0,min(255,GetInt(argv[1]))),
                                        max(0,min(255,GetInt(argv[2]))));
}

void cvlib_draw_contours::set_int_color (int argc,t_atom *argv)
{
    if (argc==3)
        if (IsFloat(argv[0])&&IsFloat(argv[1])&&IsFloat(argv[2]))
           inner_contour_color=CV_RGB(max(0,min(255,GetInt(argv[0]))),
                                        max(0,min(255,GetInt(argv[1]))),
                                        max(0,min(255,GetInt(argv[2]))));
}

void cvlib_draw_contours::set_ext_color (int argc,t_atom *argv)
{
    if (argc==3)
        if (IsFloat(argv[0])&&IsFloat(argv[1])&&IsFloat(argv[2]))
           outer_contour_color=CV_RGB(max(0,min(255,GetInt(argv[0]))),
                                        max(0,min(255,GetInt(argv[1]))),
                                        max(0,min(255,GetInt(argv[2]))));
}




FLEXT_LIB_V("cvDrawContours",cvlib_draw_contours);




