
#include "cvlib_find_contours.h"
#define CVLIB_DEBUG post


// CONSTRUCTOR
cvlib_find_contours::cvlib_find_contours()
    {
        AddOutAnything();  // contours output

        // register  methods
        FLEXT_ADDMETHOD_I(0,"draw", set_drawing_status);

        // create storage
        storage = cvCreateMemStorage(0);
        // create contour
        cvSeqSID= cvlib_createHeader(CVLIB_TYPE_CONTOUR,CVLIB_STATUS_EXTERNAL_POINTER);

        // set drawing mode  (better : call set_drawing_status)
        draw_mode=0;

    }

// DESTRUCTOR
cvlib_find_contours::~cvlib_find_contours()
    {
        cvlib_freeHeader(cvSeqSID);

    // free storage
        cvReleaseMemStorage(&storage);
    }

void cvlib_find_contours::set_drawing_status(int i)
{
    draw_mode=i;
        // force image processing on next gemstate
    output_dirty_flag=1;
}

int cvlib_find_contours::process_1channel_image(IplImage * &Source, IplImage * &Dest)
{
    // reset contours/memstorage if necessary
    if(contours!=0)
        {
            contours=0;
            cvClearMemStorage(storage);
        }

    int result=cvlib_prepareIplImage(&tempImg, Source->width, Source->height,1);

    if (result&CVLIB_RESIZED)
        if (Source->roi)
            cvSetImageROI(tempImg, cvGetImageROI(Source));
    cvCopyImage(Source, tempImg);

    // find contours and store them all as a list
    cvFindContours( tempImg, storage, &contours, sizeof(CvContour),
                CV_RETR_LIST, CV_CHAIN_APPROX_SIMPLE, cvPoint(0,0) );

    if(draw_mode)
    {
        current_contour=contours;

        while (current_contour)
        {
            cvDrawContours( tempImg, current_contour, CV_RGB(255,255,255), CV_RGB(255,255,255), 0, 1, 8 );
            current_contour=current_contour->h_next;
        }
        if(Dest!=tempImg)
        {
            Dest=tempImg;
            result |= CVLIB_RESIZED;
        }
    }
    else
        if(Dest!=Source)
        {
            Dest=Source;
            result |= CVLIB_RESIZED;
        }
            // set instance pointer to contours
    cvlib_set_pdata(cvSeqSID,contours);

            // send cv contour SID
    SETFLOAT(&my_output,cvSeqSID);
        /// Is "cvContours" a good tag choice ?
    ToOutAnything(1,gensym("cvContours"),1,&my_output);

return result;
}


FLEXT_LIB("cvFindContours",cvlib_find_contours);




