
#include "cvlib_gaussian.h"
// CONSTRUCTOR
cvlib_gaussian::cvlib_gaussian(int argc,t_atom *argv)
    {


        // add inlets for cv parameters
        AddInInt();
        AddInInt();


        // link inlets to corresponding methods
        FLEXT_ADDMETHOD(1,set_kernel_x);
        FLEXT_ADDMETHOD(2,set_kernel_y);

        // cvgaussian default values

        kernel_x= 3;
        kernel_y= 3;


        // replace cvgaussian default values by creation arguments
        if(argc >= 1)
            if  (IsFloat(argv[0]))
                set_kernel_x(GetInt(argv[0]));
        if(argc >= 2)
            if  (IsFloat(argv[1]))
                set_kernel_y(GetInt(argv[1]));


    }

// DESTRUCTOR
cvlib_gaussian::~cvlib_gaussian()
    {
// free extra ressources

    }



void cvlib_gaussian::set_kernel_x(int value)
{
     kernel_x=max(1,min(99,1+value-value%2));
         // force image processing on next gemstate
    output_dirty_flag=1;
}

void cvlib_gaussian::set_kernel_y(int value)
{
    kernel_y=max(1,min(99,1+value-value%2));
        // force image processing on next gemstate
    output_dirty_flag=1;
}

//cvgaussian works on any Channel images :
// only override process_default_image() function

int cvlib_gaussian::process_default_image(IplImage *&Source, IplImage * &Dest)
{
    //cvReleaseImage(&cvImageDest);
    int result=cvlib_prepareIplImage(&Dest, Source->width, Source->height, Source->nChannels);
    // prepare dest image with same size as original, and 1 channel
    if (result)
    {
      cvSmooth (Source, Dest, CV_GAUSSIAN, kernel_x, kernel_y, 0, 0 );
        return result;
    }
    else
    {
        cvlib_error("error (re)creating target image");
        return CVLIB_FAILED;
    }
}

FLEXT_LIB_V("cvGaussian",cvlib_gaussian);


