#ifndef INCLUDE_cvlib_hough_circles_H_
#define INCLUDE_cvlib_hough_circles_H_


#include "cvlib_ImageFilter_1_1.h"
#include <stdio.h>

class cvlib_hough_circles:
	public cvlib_ImageFilter_1_1
{
	// obligatory flext header, inherit from cvlib_base
	FLEXT_HEADER(cvlib_hough_circles,cvlib_ImageFilter_1_1)
public:
    cvlib_hough_circles(int argc,t_atom *argv);
    ~cvlib_hough_circles();

    int iterations;

protected:
    virtual int process_1channel_image (IplImage * &Source, IplImage * &Dest);

    void set_accumulator_threshold(int value);
    void set_canny_threshold(int value);
    void set_min_distance(int value);
    void set_max_radius(int value);
    void set_min_radius(int value);
    void set_dp(int value);
    void set_nightmode(int value);
    void set_drawing_status(int value);

private:
    struct  CvMemStorage *storage;
    CvSeq* circles;
    CvSeq* current_circle;
    CvSeq* result;
    int cvSeqSID;
    int accumulator_threshold;
    int canny_threshold;
    int min_radius;
    int max_radius;
    int min_distance;
    int dp;
    int nightmode;

    IplImage * tempImg;

    t_atom my_output;

  //  FLEXT_CALLBACK(bang)
    FLEXT_CALLBACK_I(set_accumulator_threshold)
    FLEXT_CALLBACK_I(set_canny_threshold)
    FLEXT_CALLBACK_I(set_min_distance)
    FLEXT_CALLBACK_I(set_min_radius)
    FLEXT_CALLBACK_I(set_max_radius)
    FLEXT_CALLBACK_I(set_dp)
  //  FLEXT_CALLBACK_I(process_cvImage)
    FLEXT_CALLBACK_I(set_nightmode)
};



// end of #ifndef statement
#endif

