#include "cvlib_image.h"

#ifdef WIN32
#include <io.h>
#endif

#if defined(__unix__) || defined(__APPLE__)
# include <unistd.h>
# include <strings.h>
#endif

#include <stdio.h>




void cvlib_image::file_open(int argc,const t_atom *argv)
{

	if (argc >= 1)
        {
        if (IsSymbol(argv[0]))
            {
                char absolute_file_name[1024];
                const char* filename;
                char dir[1024];
                cvImageNew=0;
                filename=GetString(argv[0]);
                GetCanvasDir(dir,1024) ;   // get dirname
                CVLIB_DEBUG ("path= %s", dir);
                sprintf(absolute_file_name, "%s/%s", dir, filename);  // merge dir and filename


                CVLIB_DEBUG ("trying to load absolute_file_name=%s....", absolute_file_name);
                CVLIB_DEBUG("trying to load %s",filename);



                if (strrchr(absolute_file_name,'.'))     // filename must contain a dot. if not, CvImage crashes
                    cvImageNew= cvLoadImage(absolute_file_name, -1 );

                if (cvImageNew==0)
                    {
                        CVLIB_DEBUG ("failed...");
                        CVLIB_DEBUG (" trying to load file_name=%s....", filename);
                        if (strrchr(absolute_file_name,'.'))
                            cvImageNew= cvLoadImage(filename, -1 );(filename);
                        if (cvImageNew!=0)
                            CVLIB_DEBUG ("success !");
                        else
                            CVLIB_DEBUG ("failed...");
                    }
                else
                    CVLIB_DEBUG ("success !");

                }
            if (cvImageNew != 0)
                {
                    if (cvImageDest)
                    // free cvImageDest before replacing it by cvImageNew
                    cvReleaseImage( (IplImage**)&cvImageDest);
                    cvImageDest=cvImageNew;
                }
        }
}

// CONSTRUCTOR
cvlib_image::cvlib_image(int argc,t_atom *argv)
{

    /*
    arguments :
    cv.Image <width> <height>     (defaults to 3 channels)
    cv.Image <width> <height> <channels>
    cv.Image <filename>

    methodes
    cvImage <sid>
    open <filename>
    set <width> <height>
    set <width> <height> <channels>

    */

    if (argc == 1)
    {
        if (IsSymbol(argv[0]))
        {           // load file specified as argument
            char absolute_file_name[1024];
            const char* filename;
            char dir[1024];
            cvImageNew=0;
            filename=GetString(argv[0]);
            GetCanvasDir(dir,1024) ;   // get dirname
            CVLIB_DEBUG ("path= %s", dir);
            sprintf(absolute_file_name, "%s/%s", dir, filename);  // merge dir and filename

            CVLIB_DEBUG ("trying to load absolute_file_name=%s....", absolute_file_name);
            CVLIB_DEBUG("trying to load %s",filename);

            if (strrchr(absolute_file_name,'.'))     // filename must contain a dot. if not, CvImage crashes
                cvImageNew= cvLoadImage(absolute_file_name, -1 );

            if (cvImageNew==0)
            {
                CVLIB_DEBUG ("failed...");
                CVLIB_DEBUG (" trying to load file_name=%s....", filename);
                if (strrchr(absolute_file_name,'.'))
                    cvImageNew= cvLoadImage(filename, -1 );(filename);
                if (cvImageNew!=0)
                    CVLIB_DEBUG ("success !");
                else
                    CVLIB_DEBUG ("failed...");
            }
            else
                CVLIB_DEBUG ("success !");
        }
    }
    else
            //more than one argument : check if size is specified
            // if not, load default image size
    {
        //load image size default values
        width = 320;   /// default size  TODO : #define
        height = 240;   /// default size  TODO : #define
        channels=3;  ///default image channels

        //check args for image size values
        if(argc >= 2)
        {
            if  (IsFloat(argv[0]) && IsFloat(argv[1])) // 2 first arguments ar floats
            {
                width = GetInt(argv[0]);
                height = GetInt(argv[1]);
                if (width <= 0)
                    width = 320;   /// default size  TODO : #define
                if (height <= 0)
                    height = 240;   /// default size  TODO : #define
                width = min (width, CVLIB_MAX_IMAGE_WIDTH);
                height = min (height, CVLIB_MAX_IMAGE_HEIGHT);
                CVLIB_DEBUG("creation dune image de taille %i x %i",width,height);
            }
            else
            {
                CVLIB_DEBUG("creation par defaut dune image de taille %i x %i",width,height);
            }
                   // check for 3rd argument : nb of channels
            if(argc == 3)
                if (IsFloat(argv[2]))
                {
                    channels = GetInt(argv[2]);
                    channels = min (1,max(channels, CVLIB_MAX_IMAGE_CHANNELS));
                }


        }
        // create new default image
        cvImageNew=cvCreateImage(cvSize(width, height),IPL_DEPTH_8U, channels);
    }

    // substitue cvImageNew into cvImageDest
    if (cvImageNew != 0)
    {
        if (cvImageDest!=0)
        // free cvImageDest before replacing it by cvImageNew
            cvReleaseImage( (IplImage**)&cvImageDest);
        cvImageDest=cvImageNew;
    }

    // register cv.Image methods
    FLEXT_CADDMETHOD(0,"open",file_open);
     //  FLEXT_ADDMETHOD_(0,"open",change_image);
}

// DESTRUCTOR
cvlib_image::~cvlib_image()
{
}



FLEXT_LIB_V("cvImage",cvlib_image);
