
#include "cvlib_median.h"
// CONSTRUCTOR
cvlib_median::cvlib_median(int argc,t_atom *argv)
    {


        // add inlets for cv parameters
        AddInInt();


        // link inlets to corresponding methods
        FLEXT_ADDMETHOD(1,set_neighborhood);


        // set cvmedian default values
        neighborhood=3;


        // replace cvmedian default values by creation arguments
        if(argc >= 1)
            if  (IsFloat(argv[0]))
                set_neighborhood(GetInt(argv[0]));


    }

// DESTRUCTOR
cvlib_median::~cvlib_median()
    {
// free extra ressources

    }


void cvlib_median::set_neighborhood(int value)
{
    neighborhood=max(1,min(15,1+value-value%2));
        // force image processing on next gemstate
    output_dirty_flag=1;

}



//cvmedian works on any Channel images :
// only override process_default_image() function

int cvlib_median::process_default_image(IplImage *&Source, IplImage * &Dest)
{
    //cvReleaseImage(&cvImageDest);
    int result=cvlib_prepareIplImage(&cvImageDest, cvImageSource->width, cvImageSource->height, cvImageSource->nChannels);
    // prepare dest image with same size as original, and 1 channel
    if (result)
    {
      cvSmooth (cvImageSource, cvImageDest, CV_MEDIAN, neighborhood, 0, 0, 0 );
        return result;
    }
    else
    {
        cvlib_error("error (re)creating target image");
        return CVLIB_FAILED;
    }
}

FLEXT_LIB_V("cvMedian",cvlib_median);


