#ifndef INCLUDE_cvlib_route_contours_H_
#define INCLUDE_cvlib_route_contours_H_
#define max_route_criteria 10

#include "cvlib.h"
#include <stdio.h>

class cvlib_route_contours:
	public flext_base
{
	// obligatory flext header, inherit from cvlib_base
	FLEXT_HEADER(cvlib_route_contours,flext_base)
public:
    cvlib_route_contours(int argc,t_atom *argv);
    ~cvlib_route_contours();



protected:
    void process_cvContours (int i);
    void send_cvContourSID(int outlet, int sid);

    void process_matrix(int argc,t_atom *argv);
    void process_list(int argc,t_atom *argv);
    void set_routing_element(int index, int value);

private:
    struct  CvMemStorage *storage1;
   // struct  CvMemStorage *storage2;

    CvSeq* current_contour;
    CvSeq* head_contour;

    CvSeq* head_contour_left;
    CvSeq* head_contour_right;
    CvSeq* current_contour_left;
    CvSeq* current_contour_right;


    int cvSeqSID_right;
    int parameters_count;

    CvSeq* contour_head[max_route_criteria];
    CvSeq* contour_current[max_route_criteria];
    int cvSeqSID[max_route_criteria];
    int matching_values[max_route_criteria];




    int routing_vector_size;
    int contour_processed;
    int routing_vector[CVLIB_MAX_CONTOURS];


    t_atom my_output;
 //   FLEXT_CALLBACK(bang)
    FLEXT_CALLBACK_V(process_matrix)
    FLEXT_CALLBACK_V(process_list)
    FLEXT_CALLBACK_I(process_cvContours)
    FLEXT_CALLBACK_II(set_routing_element)

};



// end of #ifndef statement
#endif

