
#include "cvlib_route_contours.h"
#define CVLIB_DEBUG post


// CONSTRUCTOR
cvlib_route_contours::cvlib_route_contours(int argc,t_atom *argv)
    {
        AddInAnything();        // cvContours messages
        AddInAnything();        // matrix messages

        AddOutAnything();
        AddOutAnything();

        FLEXT_ADDMETHOD_I(0,"cvContours",process_cvContours);  // register method for tag "cvContours" and int argument
        FLEXT_ADDMETHOD_(1,gensym("matrix"),process_matrix);
        FLEXT_ADDMETHOD(1,process_list);
        routing_vector_size=0;
        contour_processed=0;

    // create storage
        storage1 = cvCreateMemStorage(0);
   //     storage2 = cvCreateMemStorage(0);

    // create contour
        cvSeqSID1= cvlib_createHeader(CVLIB_TYPE_CONTOUR,CVLIB_STATUS_EXTERNAL_POINTER);
        cvSeqSID2= cvlib_createHeader(CVLIB_TYPE_CONTOUR,CVLIB_STATUS_EXTERNAL_POINTER);

    // argument extraction
     /*   if(argc >= 1)
            if  (IsFloat(argv[0]))
                set_iterations(GetInt(argv[0]));  */
    }

// DESTRUCTOR
cvlib_route_contours::~cvlib_route_contours()
    {
        cvlib_freeHeader(cvSeqSID1);
        cvlib_freeHeader(cvSeqSID2);
     // free storage
        cvReleaseMemStorage(&storage1);
    }

/// TO DO : add method for ramdom access


void cvlib_route_contours::process_matrix(int argc,t_atom *argv)
{
    routing_vector_size=0;
    contour_processed=0;
    if (argc>=2)
        if ((IsFloat(argv[0]))&&IsFloat(argv[1]))

            if (GetFloat(argv[1])==1)
            {
                routing_vector_size=GetFloat(argv[0]);
                if(routing_vector_size!=argc-2)
                {
                    cvlib_error("cvRouteContours error : incorrect vector length");
                    routing_vector_size=0;
                }
            }

            else
                cvlib_error("cvRouteContours error : incorrect matrix dimensions [%d %d]",(int)GetFloat(argv[0]),(int)GetFloat(argv[1]));
        else
            cvlib_error("cvRouteContours error : incorrect matrix arguments type");
    if (routing_vector_size)
    {

        for (int i=0;i<routing_vector_size; i++)
            if (IsFloat(argv[i+2]))
                routing_vector[i]=GetInt(argv[i+2]);
            else
                {
                    cvlib_error("cvRouteContours error : incorrect vector element type");
                    routing_vector_size=0;
                    break;
                }
    }

 }

void cvlib_route_contours::process_list(int argc,t_atom *argv)
{
    if (argc==0)   // bang
        routing_vector_size=0;
        //routing_vector_size+=argc;

    if (argc)
    {
        if (contour_processed)  // reset routing vector
        {
            routing_vector_size=0;
            contour_processed=0;
        }
        if(argc+routing_vector_size<CVLIB_MAX_CONTOURS)
        {
            for (int i=0;i<argc; i++)
            {
                if (IsFloat(argv[i]))
                    routing_vector[routing_vector_size+i]=GetInt(argv[i]);
                else
                    {
                        cvlib_error("cvRouteContours error : incorrect vector element type");

                        break;
                    }
            }
            routing_vector_size+=argc;
        }
        else
            cvlib_error("cvRouteContours error : max vector length overriden");



    }
 }




void cvlib_route_contours::send_cvContourSID(int outlet, int sid)
{
    if (sid>=0)
        {
        SETFLOAT(&my_output,sid);
        /// Is "cvContours" a good tag choice ?
         ToOutAnything(outlet,gensym("cvContours"),1,&my_output);
        }
}



void cvlib_route_contours::process_cvContours(int sid)
{

    if (cvlib_get_type(sid)==CVLIB_TYPE_CONTOUR)
    {
        current_contour=(CvSeq*)cvlib_get_pdata(sid);
        if (current_contour)
        {


            head_contour_left=head_contour_right=current_contour_left=current_contour_right=0;

            for (int i = 0; i < routing_vector_size; i++)
            {

                if(!routing_vector[i])
                // push contour into left sequence
                {
                    if(head_contour_left==0)
                        current_contour_left=head_contour_left=(CvSeq*)cvCloneSeq(current_contour,storage1);
                    else
                    {
                        current_contour_left->h_next=(CvSeq*)cvCloneSeq(current_contour,storage1);
                        current_contour_left=current_contour_left->h_next;
                    }
                }
                else
                // push contour into right sequence
                {
                    if(head_contour_right==0)
                        current_contour_right=head_contour_right=(CvSeq*)cvCloneSeq(current_contour,storage1);
                    else
                    {
                        current_contour_right->h_next=(CvSeq*)cvCloneSeq(current_contour,storage1);
                        current_contour_right=current_contour_right->h_next;
                    }
                }
                current_contour=current_contour->h_next;
                if (current_contour==0)
                    break;

            }
            // close properly cvsequences
            if(current_contour_left!=0)
                current_contour_left->h_next=0;
            if(current_contour_right!=0)
                current_contour_right->h_next=0;
            // set instance pointer to contours
            cvlib_set_pdata(cvSeqSID1,head_contour_left);
            cvlib_set_pdata(cvSeqSID2,head_contour_right);

            // send cv contour SIDs
            send_cvContourSID(1,cvSeqSID2);
            send_cvContourSID(0,cvSeqSID1);

            // clear memory storage - reset free space position
            cvClearMemStorage(storage1);
        }
    contour_processed=1;
    }

}


FLEXT_LIB_V("cvRouteContours",cvlib_route_contours);




