
#include "cvlib_set_roi.h"
// CONSTRUCTOR
cvlib_set_roi::cvlib_set_roi(int argc,t_atom *argv)
    {
        AddInAnything();
        cvImageWithROI=cvCreateImageHeader(cvSize(320, 240), IPL_DEPTH_8U, 4);

        roi_changed=0;

        FLEXT_ADDMETHOD(1,process_list);
        if(argc==4)
            process_list(argc,argv);

    }

// DESTRUCTOR
cvlib_set_roi::~cvlib_set_roi()
    {
// free extra ressources
cvReleaseImageHeader(&cvImageWithROI);
    }


//cvSetRoi works on any Channel images :
// only override process_default_image() function

int cvlib_set_roi::process_default_image(IplImage *&Source, IplImage * &Dest)
{
    //cvReleaseImage(&cvImageDest);
    int result=cvlib_prepareIplImage(&cvImageTemp, Source->width, Source->height, Source->nChannels);
    // prepare dest image with same size as original, and 1 channel
    if (result)
    {
        if (result & CVLIB_RESIZED)
        {
            *cvInitImageHeader( cvImageWithROI, cvSize(Source->width,Source->height), Source->depth,
                             Source->nChannels, Source->origin, Source->align);

            cvImageWithROI->imageData=Source->imageData;
            roi_changed=1;
        }
        if(roi_changed)
        {
            if((my_roi.width==0)||(my_roi.height==0))
                cvResetImageROI(cvImageWithROI);
            else
                cvSetImageROI(cvImageWithROI, my_roi);
            roi_changed=0;
        }
       //
        Dest=cvImageWithROI;
        return result;
    }
    else
    {
        cvlib_error("error (re)creating target image");
        return CVLIB_FAILED;
    }
}

int cvlib_set_roi::process_roi_IplImage(IplImage * &Source, IplImage * &Dest)
{

    return (process_IplImage(Source, Dest));
}

void cvlib_set_roi::process_list(int argc,t_atom *argv)
{
    if(argc==4)
    {
        if(IsFloat(argv[0])&&IsFloat(argv[1])&&IsFloat(argv[2])&&IsFloat(argv[3]))
        {
            my_roi.x=GetFloat(argv[0]);
            my_roi.y=GetFloat(argv[1]);
            my_roi.width=GetFloat(argv[2]);
            my_roi.height=GetFloat(argv[3]);
            roi_changed=1;
        }
        else
        cvlib_error("cvSetRoi : incorrect data passed on right inlet");
    }
}

FLEXT_LIB_V("cvSetRoi",cvlib_set_roi);


