#include "cvlib_show_image.h"




int cvlib_show_image_instance = 0;
cvlib_show_image::cvlib_show_image(int argc,t_atom *argv)
    {
        fixed_size=0;
        vis=1;
        imagesize.width=imagesize.height=256;

        if(argc >= 1 && IsSymbol(argv[0])) // one symbol given as argument
		{
           memcpy(wndname, GetString(argv[0]), 24);  //copy symbol argument into string
           if ((argc >= 3) && IsFloat(argv[1])&&IsFloat(argv[2]))
                 {
                     fixed_size=1;
                    imagesize.width= max(0, GetInt(argv[1]));
                    imagesize.height= max(0, GetInt(argv[2]));
                 }
		}

	else {
		   sprintf (wndname, "ShowImage:untitled%d", ++cvlib_show_image_instance);
		   if ((argc == 2) && IsFloat(argv[0])&&IsFloat(argv[1]))
                {
                    fixed_size=1;
                    imagesize.width= max(0, GetInt(argv[0]));
                    imagesize.height= max(0, GetInt(argv[1]));
                 }
         }

        FLEXT_ADDMETHOD_I(0,"vis",show_hide);  // register method for tag "image" and int argument


        previous_imagesize.height=0;
        previous_imagesize.width=0;
        cvNamedWindow(wndname, 0);
        cvResizeWindow( wndname, imagesize.width, imagesize.height );

    }


cvlib_show_image::~cvlib_show_image()
    {
      cvDestroyWindow(wndname);
    }

int cvlib_show_image::process_default_image(IplImage * &Source, IplImage * &Dest)

{
        int result=cvlib_prepareIplImage(&tempImg, Source->height, Source->width, Source->nChannels);
        Dest=Source;
        imagesize = cvGetSize(Source);
        if ((previous_imagesize.height!=imagesize.height) ||previous_imagesize.width!=imagesize.width)
            {
                previous_imagesize.width=imagesize.width;
                previous_imagesize.height=imagesize.height;
                if(vis&&!fixed_size)
                    cvResizeWindow(wndname, imagesize.width, imagesize.height);
            }

    //    CVLIB_DEBUG("size =(%d,%d)", imagesize.width, imagesize.height);
        if (vis)
            cvShowImage(wndname, Source);
       // cvWaitKey(1);
return (result);
}

int cvlib_show_image::process_roi_IplImage(IplImage * &Source, IplImage * &Dest)
{

    return (process_IplImage(Source, Dest));

}


void cvlib_show_image::show_hide(int flag)
    {
      vis=max(0,min(1,flag));
      if (vis)
        {
        cvNamedWindow(wndname, 0);
        if(!fixed_size)
        cvResizeWindow( wndname, imagesize.width, imagesize.height );
        }
      else
        cvDestroyWindow(wndname);
    }




FLEXT_LIB_V("cvShowImage",cvlib_show_image);
